﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.JavaScript;
using Syncfusion.JavaScript.DataSources;
using System.Collections;
using samplebrowser.Models;
using System.ComponentModel.DataAnnotations;

namespace ejGridASPCore.Controllers
{
    public partial class HomeController : Controller
    {
        public IActionResult Index()
        {
            if (order.Count() == 0)
                BindDataSource();
            ViewBag.child1 = order;
            return View();
        }
        public static List<AlarmModel> alaram = new List<AlarmModel>();
        public static List<Orders> order = new List<Orders>();
        public void BindDataSource()
        {
            int code = 10000;
            for (int i = 1; i < 10; i++)
            {
                order.Add(new Orders((code + 1), "ALFKI", 1, 2.3 * i, new DateTime(1991, 05, 15), "Berlin", new List<AlarmModel>() { new AlarmModel() { DetailsID=1,  Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 2), "ANATR", 2, 3.3 * i, new DateTime(1990, 04, 04), "Madrid", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 3), "ANTON", 3, 4.3 * i, new DateTime(1957, 11, 30), "Cholchester", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 4), "BLONP", 4, 5.3 * i, new DateTime(1930, 10, 22), "Marseille", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                order.Add(new Orders((code + 5), "BOLID", 5, 6.3 * i, new DateTime(1953, 02, 18), "Tsawassen", new List<AlarmModel>() { new AlarmModel() { DetailsID = 1, Date = new DateTime(), Description = "This is Hierarchy Level" }, new AlarmModel() { DetailsID = 2, Date = new DateTime(1991, 05, 15), Description = "This is Hierarchy Level" } }));
                code += 5;
            }
        }
        public class Orders
        {
            public Orders()
            {

            }
            public Orders(int ID, string CustomerId, int EmployeeId, double Freight, DateTime OrderDate, string AdresseTyp, IList<AlarmModel> alarm)
            {
                this.ID = ID;
                this.CustomerID = CustomerId;
                this.EmployeeID = EmployeeId;
                this.Freight = Freight;
                this.OrderDate = OrderDate;
                this.AdresseTyp = AdresseTyp;
                this.Alarms = alarm;
            }
            [Required]
            public int ID { get; set; }
            public string CustomerID { get; set; }
            public int EmployeeID { get; set; }
            public double Freight { get; set; }
            public DateTime OrderDate { get; set; }
            public string AdresseTyp { get; set; }
            public IList<AlarmModel> Alarms { get; set; }
        }
        public class AlarmModel
        {
            public long DetailsID { get; set; }
            public string Description { get; set; }
            public DateTime Date { get; set; }
        }
        public ActionResult CellEditUpdate([FromBody]CRUDModel<Orders> value)
        {
            var ord = value.Value;
            Orders val = order.Where(or => or.ID == ord.ID).FirstOrDefault();
            val.ID = ord.ID;
            val.EmployeeID = ord.EmployeeID;
            val.CustomerID = ord.CustomerID;
            val.Freight = ord.Freight;
            val.OrderDate = ord.OrderDate;
            val.AdresseTyp = ord.AdresseTyp;
            val.Alarms = new List<AlarmModel>();
            return Json(value.Value);
        }
        public ActionResult CellEditInsert([FromBody]CRUDModel<Orders> value)
        {
            value.Value.ID = order.LastOrDefault().ID + 1;
            order.Insert(0, value.Value);
            return Json(value.Value);
        }
        public ActionResult CellEditDelete([FromBody]CRUDModel<Orders> value)
        {
            order.Remove(order.Where(or => or.ID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return Json(value);
        }
        public ActionResult CellEditInsertDetail([FromBody]CRUDModel<AlarmModel> value)
        {
            Random ran = new Random();
            value.Value.DetailsID = ran.Next();
            int readonlyID = int.Parse(Request.Headers["ID"]);
            Orders ord = order.Where(or => or.ID == readonlyID).FirstOrDefault();
            ord.Alarms.Add(value.Value);
            return Json(value.Value);
        }
        public ActionResult CellEditDeleteDetail([FromBody]CRUDModel<AlarmModel> value)
        {
            //order.Remove(order.Where(or => or.ID == value.Key.ToString()).FirstOrDefault());
            int readonlyID = int.Parse(Request.Headers["ID"]);
            Orders ord = order.Where(or => or.ID == readonlyID).FirstOrDefault();
            ord.Alarms.Remove(ord.Alarms.Where(al => al.DetailsID == int.Parse(value.Key.ToString())).FirstOrDefault());
            return Json(value);
        }
    }
}
